//+-------------------------------------------------------------------+
//|                                              Sup_a_Res_v1.2.mq4   |
//|                                         Made/Modified by Figar0   |
//|                                                  figaro@mail.ru   |
//|                                                                   |
//+-------------------------------------------------------------------+
#property copyright "Figar0"
#property link      "figaro@mail.ru"
#property indicator_buffers 4
#property indicator_chart_window
//----

extern int  FirstBar     =2;
extern int  Sensitivity  =15 ;
extern int  Delta        =10;
extern bool DrawFibo     =true;
//----



double S1,S2,S3,R1,R2,R3,F1,F2;
int RR1,RR2, RR3, SS1,SS2,SS3;


double s1buffer[];
double r1buffer[];
double s2buffer[];
double r2buffer[];
   int cnt1, cntS=0,cntR=0, Resistance_Counter=0, Support_Counter=0;
   double   ZZ_Resistance[5][3]={ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,  0 },
   ZZ_Support[5][3]={ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,  0 },
   ZZ0=0,ZZ1=0,ZZ2=0,current_price=0, last_support=0,last_resistence=0;   
bool First; 

//int PrevTime=0;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   R1=0; R2=0; R3=0; F1=0; F2=0;
   S1=0; S2=0; S3=0;

//----

   SetIndexStyle(0,DRAW_LINE,EMPTY,3);
   SetIndexBuffer(0, s1buffer);
   SetIndexStyle(1,DRAW_LINE,EMPTY,3);
   SetIndexBuffer(1, r1buffer);
   SetIndexStyle(2,DRAW_LINE,EMPTY,3);
   SetIndexBuffer(2, s2buffer);
   SetIndexStyle(3,DRAW_LINE,EMPTY,3);
   SetIndexBuffer(3, r2buffer);
   ZZ_Resistance[5][3]={ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,  0 };
   ZZ_Support[5][3]={ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,  0 };
   ZZ0=0;ZZ1=0;ZZ2=0;current_price=0; last_support=0;last_resistence=0;   

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//---- TODO: add your code here
   ObjectDelete("R1 Label");
   ObjectDelete("R1 Line");
   ObjectDelete("R2 Label");
   ObjectDelete("R2 Line");
   ObjectDelete("R3 Label");
   ObjectDelete("R3 Line");
   ObjectDelete("S1 Label");
   ObjectDelete("S1 Line");
   ObjectDelete("S2 Label");
   ObjectDelete("S2 Line");
   ObjectDelete("S3 Label");
   ObjectDelete("S3 Line");
   ObjectDelete("Fibo");

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   ZZ_Resistance[5][3]={ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,  0 };
   ZZ_Support[5][3]={ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,  0 };
   ZZ0=0;ZZ1=0;ZZ2=0;current_price=0; last_support=0;last_resistence=0;   
   RR1=0;RR2=0; RR3=0; SS1=0;SS2=0;SS3=0;
   R1=0; R2=0; R3=0; F1=0; F2=0;
   S1=0; S2=0; S3=0;
 // bool First=true;
 
   ObjectDelete("R1 Label");
   ObjectDelete("R1 Line");
   ObjectDelete("R2 Label");
   ObjectDelete("R2 Line");
   ObjectDelete("R3 Label");
   ObjectDelete("R3 Line");
   ObjectDelete("S1 Label");
   ObjectDelete("S1 Line");
   ObjectDelete("S2 Label");
   ObjectDelete("S2 Line");
   ObjectDelete("S3 Label");
   ObjectDelete("S3 Line");
   ObjectDelete("Fibo");

   if (true)//(iTime(NULL,0,0)>PrevTime)
   {
     //PrevTime=iTime(NULL,0,0);
     current_price=Bid;
     last_support=current_price;
     last_resistence=current_price; 
     Resistance_Counter=0;
     Support_Counter=0;
     First=true;
     cntS=0;cntR=0;
     for (cnt1=FirstBar;cnt1<iBars(NULL,0);cnt1++)
     {
       ZZ0=iCustom(NULL,0,"ZigZag",Sensitivity,5,3,0,cnt1);
       ZZ1=iCustom(NULL,0,"ZigZag",Sensitivity,5,3,1,cnt1);
       ZZ2=iCustom(NULL,0,"ZigZag",Sensitivity,5,3,2,cnt1);
       
 
       if (ZZ1>0.0001 && ZZ0>0.0001)
       {  
        // if (First) {First=false;last_resistence=ZZ1;continue;}
         Resistance_Counter++; 
        // last_resistence=ZZ1;
         if ((( ZZ1>last_resistence+Delta*Point && ZZ1>High[iHighest(NULL,0,MODE_HIGH,cnt1,0)])|| (First && ZZ1>last_resistence) )&& cntR<5) 
         {          
           First=false;    
           last_resistence=ZZ1;
           ZZ_Resistance[cntR][0]=ZZ1; ZZ_Resistance[cntR][1]=Resistance_Counter; ZZ_Resistance[cntR][2]=cnt1;
           cntR++;
         }
       }
       if (ZZ2>0.0001 && ZZ0>0.0001)
       {  
        //if (First) {First=false; last_support=ZZ2; continue;}
       //  last_support=ZZ2; 
         Support_Counter++;
         if (( (ZZ2<last_support-Delta*Point && ZZ2<Low[iLowest(NULL,0,MODE_LOW,cnt1,0)]) || ( First && ZZ2<last_support)) && cntS<5)  
         { 
           First=false;   
           last_support=ZZ2;
           ZZ_Support [cntS][0]=ZZ2; ZZ_Support [cntS][1]=Support_Counter; ZZ_Support [cntS][2]=cnt1;
           cntS++;
         }
       }
       if (cntS>=5 && cntR>=5) break;    
     }

   }

   int i=0, j=0;
//---- TODO: add your code here

   R1=ZZ_Resistance [0][0];
   RR1=ZZ_Resistance [0][1];
   string RRR1=RR1;
   S1=ZZ_Support [0][0];
   SS1=ZZ_Support [0][1];
   string SSS1=SS1;
   R2=ZZ_Resistance [1][0];
   RR2=ZZ_Resistance [1][1];
   string RRR2=RR2;
   S2=ZZ_Support [1][0];
   SS2=ZZ_Support [1][1];
   string SSS2=SS2;   
   R3=ZZ_Resistance [2][0];
   RR3=ZZ_Resistance [2][1];
   string RRR3=RR3;
   S3=ZZ_Support [2][0];
   SS3=ZZ_Support [2][1];
   string SSS3=SS3;
   if (ZZ_Support [0][2]>ZZ_Resistance [0][2]) {F1=S1; F2=R1;}
   else {F1=R1; F2=S1;}
//---- Pivot Lines
   if (true)
     {
      //---  Draw  Pivot lines on chart
      if(ObjectFind("S1 line")!=0)
        {
         ObjectCreate("S1 line", OBJ_HLINE, 0, Time[40], S1);
         ObjectSet("S1 line", OBJPROP_STYLE, STYLE_SOLID);
         ObjectSet("S1 line", OBJPROP_COLOR, Red);
        }
      else
        {
         ObjectMove("S1 line", 0, Time[40], S1);
        }
      if(ObjectFind("S2 line")!=0)
        {
         ObjectCreate("S2 line", OBJ_HLINE, 0, Time[40], S2);
         ObjectSet("S2 line", OBJPROP_STYLE, STYLE_SOLID);
         ObjectSet("S2 line", OBJPROP_COLOR, Red);
        }
      else
        {
         ObjectMove("S2 line", 0, Time[40], S2);
        }
      if(ObjectFind("S3 line")!=0)
        {
         ObjectCreate("S3 line", OBJ_HLINE, 0, Time[40], S3);
         ObjectSet("S3 line", OBJPROP_STYLE, STYLE_SOLID);
         ObjectSet("S3 line", OBJPROP_COLOR, Red);
        }
      else
        {
         ObjectMove("S3 line", 0, Time[40], S3);
        }

      if(ObjectFind("R1 line")!=0)
        {
         ObjectCreate("R1 line", OBJ_HLINE, 0, Time[40], R1);
         ObjectSet("R1 line", OBJPROP_STYLE, STYLE_SOLID);
         ObjectSet("R1 line", OBJPROP_COLOR, Blue);
        }
      else
        {
         ObjectMove("R1 line", 0, Time[40], R1);
        }
      if(ObjectFind("R2 line")!=0)
        {
         ObjectCreate("R2 line", OBJ_HLINE, 0, Time[40], R2);
         ObjectSet("R2 line", OBJPROP_STYLE, STYLE_SOLID);
         ObjectSet("R2 line", OBJPROP_COLOR, Blue);
        }
      else
        {
         ObjectMove("R2 line", 0, Time[40], R2);
        }
      if(ObjectFind("R3 line")!=0)
        {
         ObjectCreate("R3 line", OBJ_HLINE, 0, Time[40], R3);
         ObjectSet("R3 line", OBJPROP_STYLE, STYLE_SOLID);
         ObjectSet("R3 line", OBJPROP_COLOR, Blue);
        }
      else
        {
         ObjectMove("R3 line", 0, Time[40], R3);
        }     
      if(ObjectFind("R1 label")!=0)
        {
         ObjectCreate("R1 label", OBJ_TEXT, 0, Time[25], R1);
         ObjectSetText("R1 label", RRR1, 14, "Arial", LightBlue);
        }
      else
        {
         ObjectMove("R1 label", 0, Time[25], R1);
        }
      r1buffer[0]=R1;
//----
      if(ObjectFind("R2 label")!=0)
        {
         ObjectCreate("R2 label", OBJ_TEXT, 0, Time[25], R2);
         ObjectSetText("R2 label", RRR2, 14, "Arial", LightBlue);
        }
      else
        {
         ObjectMove("R2 label", 0, Time[25], R2);
        }
      r2buffer[0]=R2;
//----
      if(ObjectFind("R3 label")!=0)
        {
         ObjectCreate("R3 label", OBJ_TEXT, 0, Time[25], R3);
         ObjectSetText("R3 label", RRR3, 14, "Arial", LightBlue);
        }
      else
        {
         ObjectMove("R3 label", 0, Time[25], R3);
        }

//----
      if(ObjectFind("S1 label")!=0)
        {
         ObjectCreate("S1 label", OBJ_TEXT, 0, Time[25], S1);
         ObjectSetText("S1 label", SSS1, 14, "Arial", Pink);
        }
      else
        {
         ObjectMove("S1 label", 0, Time[25], S1);
        }
      s1buffer[0]=S1;
//----
      if(ObjectFind("S2 label")!=0)
        {
         ObjectCreate("S2 label", OBJ_TEXT, 0, Time[25], S2);
         ObjectSetText("S2 label", SSS2, 14, "Arial", Pink);
        }
      else
        {
         ObjectMove("S2 label", 0, Time[25], S2);
        }
      s2buffer[0]=S2;
//----
      if(ObjectFind("S3 label")!=0)
        {
         ObjectCreate("S3 label", OBJ_TEXT, 0, Time[25], S3);
         ObjectSetText("S3 label", SSS3, 14, "Arial", Pink);
        }
      else
        {
         ObjectMove("S3 label", 0, Time[25], S3);
        }


      if (DrawFibo)
      {
       ObjectDelete("Fibo");
       ObjectCreate("Fibo", OBJ_FIBO, 0,  Time[0], F1, Time[17], F2);
      } 

        
     }

 
//---- End Of Program
   return(0);
  }
//+------------------------------------------------------------------+